//ascii
#include <windows.h>
DWORD repaintcount = 0;
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
WNDCLASSEXA wc;
MSG msg;
wc.cbSize = sizeof(WNDCLASSEX);
wc.style = 0;
wc.lpfnWndProc = WndProc;
wc.cbClsExtra = 0;
wc.cbWndExtra = 0;
wc.hInstance = hInstance;
wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
wc.hCursor = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
wc.lpszMenuName = NULL;
wc.lpszClassName = "myWindowClass";
wc.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
RegisterClassEx(&wc);
CreateWindowExA(WS_EX_CLIENTEDGE, "myWindowClass", "Text Output", WS_VISIBLE | WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, 700, 200, NULL, NULL, hInstance, NULL);
while (GetMessage(&msg, NULL, 0, 0) > 0)
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}
return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
PAINTSTRUCT Ps;
HDC hdc;
SIZE size;
char str[100]="\0";
HFONT font;
HBRUSH hBrush;
TEXTMETRIC tm;
int y=0;
int x=0;
int textlength;
switch (msg)
{
case WM_PAINT://traps paint message
//text output using default font
hdc = BeginPaint(hwnd, &Ps);
int hDCLast;
hDCLast=SaveDC(hdc);
textlength=wsprintf(str,"Stock font");
TextOutA(hdc,0,y,str,textlength);
//select ANSI_FIXED_FONT and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;//calculate new vertical coordinate using text metric
hBrush=(HBRUSH)GetStockObject(ANSI_FIXED_FONT);
SelectObject(hdc,hBrush);
//sprintf(str,"ANSI_FIXED_FONT");
textlength=wsprintf(str,"ANSI_FIXED_FONT" );
TextOutA(hdc,0,y,str,textlength);
//set text to red and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;
COLORREF newtextcolour;
newtextcolour=COLORREF RGB(255, 0, 0);
SetTextColor(hdc,newtextcolour);
textlength=wsprintfA(str,"ANSI_FIXED_FONT, colour red" );//ANSI_FIXED_FONT, colour red
TextOutA(hdc,x,y,str,textlength);
//set text background to blue and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;
COLORREF newbkcolour;
newbkcolour=COLORREF RGB(0, 0, 255);
SetBkColor(hdc,newbkcolour);
//sprintf(str,"ANSI_FIXED_FONT, colour red with blue background");
textlength=wsprintf(str, "ANSI_FIXED_FONT, colour red with blue background" );//ANSI_FIXED_FONT, colour red
TextOutA(hdc,x,y,str,textlength);
//set text background to transparent and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;
SetBkMode(hdc,TRANSPARENT);
SelectObject(hdc,hBrush);
//sprintf(str,"ANSI_FIXED_FONT, colour red transparent background");
textlength=wsprintfA(str,"ANSI_FIXED_FONT,colour red transparent background" );//ANSI_FIXED_FONT, colour red
TextOutA(hdc,0,y,str,textlength);
//select font Ariel 20 and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;
font = CreateFontA(20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Ariel");
SelectObject(hdc,font);
textlength=wsprintfA(str,"ANSI_FIXED_FONT, colour red, transparent background,arial 20" );//ANSI_FIXED_FONT, colour red
//sprintf(str,"ANSI_FIXED_FONT, colour red, transparent background,arial 20");
TextOutA(hdc,0,y,str,textlength);
//restore default font using saved value and output text
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;
RestoreDC(hdc,hDCLast);
textlength=wsprintfA(str,"stock font restored using SaveDC/RestoreDC" );//ANSI_FIXED_FONT, colour red
//sprintf(str,"stock font restored using SaveDC/RestoreDC");
TextOutA(hdc,x,y,str,textlength);
GetTextMetricsA(hdc,&tm);
y=y+tm.tmHeight;//calculate new vertical coordinate using text metric
//select font times new romans 30 and output text
int baseline;//used to caculate font baseline
font = CreateFontA(30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Times New Roman");
SelectObject(hdc,font);
GetTextMetricsA(hdc,&tm);
baseline=tm.tmAscent;
//sprintf(str,"times new roman 30 statement 1");
textlength=wsprintf(str,"times new roman 30 statement 1" );
TextOutA(hdc,x,y,str,textlength);
GetTextExtentPoint32A(hdc,str,textlength,&size);
x=x+size.cx;
//select font courier new 20 and output text
int baselinecourier;
font = CreateFontA(20, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Courier New");
SelectObject(hdc,font);
GetTextMetricsA(hdc,&tm);
baselinecourier=baseline-tm.tmAscent;
//sprintf(str,"Courier statement 2");
textlength=wsprintfA(str, "Courier statement " );
TextOutA(hdc,x,y+baselinecourier,str,textlength);
GetTextExtentPoint32A(hdc,str,textlength,&size);
x=x+size.cx;
//select font ariel 20 and output text
int baselineariel;
font = CreateFontA(10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Ariel");
SelectObject(hdc,font);
GetTextMetricsA(hdc,&tm);
baselineariel=baseline-tm.tmAscent;
textlength=wsprintfA(str, "ariel 10 statement 3 " );
TextOutA(hdc,x,y+baselineariel,str,textlength);
EndPaint(hwnd, &Ps);
DeleteDC(hdc);
DeleteObject(font);
DeleteObject(hBrush);
break;
case WM_CLOSE:
DestroyWindow(hwnd);
break;
case WM_DESTROY:
PostQuitMessage(0);
break;
default:
return DefWindowProcA(hwnd, msg, wParam, lParam);
}
return 0;
}